(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
      Dmo de quelques effets graphiques (zoom, fondu, inversion, ...)      
Ĵ
  Fichier ncessaire                                                      
                                                      
                                                                            
 Une image au format PCX compresse v5.0 en 320x200 pixels et 256 couleurs  
Ĵ
  Version                                                                 
                                                                 
                                                                            
 20/02/1999: - Version 1.0 (dbut de l'inscription des modifs)              
             - Deboggage du fondu 'noir -> couleurs' -> un 'LitPal' trainait
               par l                                                       
*)

{$M 4096,0,100000}
{$G+ :Utilise les fonctions du 286 : SHL & SHR (multiplication ultra rapide) }

uses
  Clavier,EcranTxt,EcranVga,FaitPaus,GestFich,PalVideo,Pcx,StopProg;

var
  Image: PtrImage;

  NomImage: string;

  Pal,SauvePal : Array [0..255] of RVB;
  LigneH,LigneB: Array [0..319] of byte;

  zoom : shortint;

  i,ix,iy, vram: word;

  blanc,noir,    { Pour l'affichage du texte }
  R,V,B: byte;   { Pour l'dition de la palette }

procedure AfficheImage (txt: string); begin
  AffichePtr (Image);

  EcriTsp (-1,0,txt,noir);
  EcriTsp (-1,1,txt,blanc);
  Pause (1000);
end;

procedure Init;
var Larg,Haut: Word; Bpp: Byte;
begin
  { Lit le nom de l'image dans le PSP ou le demande }
  NomImage := ParamStr(1);
  if NomImage='' then begin
    EffaceEcranTxt;
    EcriTcr ('Entrez le nom d''une image au format PCX v5.0 en 320x200 pixels et 256 couleurs :',15);
    if (not LitTxt (NomImage,13,15+3*16,14+1*16)) or (NomImage='') then begin
      SauteLigne;
      Halt;
    end;
  end;

  { L'image existe au moins ? }
  AjouteExtNomFich (NomImage,'pcx');
  if not FichierExistant(NomImage) then
    StopProgramInfo ('la vrification de l''image','Fichier introuvable','fichier:'+NomImage);

  { Vrifie le format de l'image }
  LitTailleImagePcx (NomImage, Larg, Haut, Bpp);
  if (Larg<>320) or (Haut<>200) or (Bpp<>8) then
    StopProgramInfo ('la vrification de l''image',
                     'Elle doit tre au format PCX : 320x200 pixels en 265 couleurs','fichier:'+NomImage);

  { Alloue de la mmoire (si possible) }
  if MemAvail<64000 then begin
    ModeTxt;
    Writeln ('Pas assez de mmoire libre pour cre un double buffer !');
    Writeln ('(Manque ',64000-MemAvail,' octets)');
    Halt (8);
  end;
  GetMem (Image,64000);

  ModeVga256;

  ChargePcx (Image,NomImage);

  blanc := CouleurBlanche;
  noir := CouleurNoire;

  Randomize;
end;

procedure Fin; begin
  ModeTxt;
  FreeMem (Image,64000);
  Halt;
end;

procedure Adouci_AsmPur; assembler; asm
  mov ax,0A000h
  mov es,ax           { ES -> Segment de l'cran   }

@PasDeTouche:         { ---- Boucle principale --- }
  mov cx,64000        { 64000 boucles (320x200)    }

@BoucleDI:

  { --- Calcul la moyenne des 4 pixels --- }
  xor ah,ah           { AH = 0           }

  mov al,es:[di-1]    { 1 pixel         }

  add al,es:[di+1]    { 2 pixel         }
  adc ah,0            { AH = AH + 9 bits de AL (dbordement) }

  add al,es:[di-320]  { 3 pixel         }
  adc ah,0            { AH + Dbordement }

  add al,es:[di+320]  { 4 pixel         }
  adc ah,0            { AH + Dbordement }

  shr ax,2            { AL = AX/4        }

  { --- Ecrit ce pixel --- }
  mov es:[di],al

  { --- LOOP @BoucleDI ---  }
  dec cx              { CX = CX - 1                }
  mov di,cx           { DI = Offset de l'cran     }
  or cx,cx            { Test si CX = 0             }
  jne @BoucleDI       { Non, on recommence tout    }

  { --- Une pause de 0,01s --- }
  mov cx, 1        { CX : Mot de poids fort   du compteur }
  xor dx, dx       { DX : Mot de poids faible du compteur }
  mov ah, 86h      { Fonction 86h }
  int 15h          { Interruption 15h }

  { --- Une touche a t presse ? --- }
  mov ah,01h
  int 16h             { Une touche a t presse ? }
  jz  @PasDeTouche    { Non, on recommance tout    }
end;

begin
  Init;

  { --- Jeu echec (case noir/blanc) --- }
  AfficheImage ('Jeu d''echec'); vram := 0;
  for iy := 0 to 99 do begin
    for ix := 0 to 159 do Mem[$A000: vram+ix*2] := 0;
    inc (vram,320);

    for ix := 0 to 159 do Mem[$A000: vram+ix*2+1] := 0;
    inc (vram,320);
  end;
  Pause (2000); if TouchPresse then Fin;

  { --- Fondus --- }
  AfficheImage ('Fondu');

  { Sauve la palette }
  LitGrandePal (Pal, 0,256);
  move (Pal,SauvePal,SizeOf(Pal));

  { Couleurs origines -> Noir }
  LitGrandePal (Pal,0,256);
  for ix := 0 to 30 do begin
    for i:=0 to 255 do
      with Pal[i] do
      begin
        if R<3 then R:=0 else dec (R,3);
        if V<3 then V :=0 else dec ( V,3);
        if B<3 then B :=0 else dec ( B,3);
      end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);

    Pause (50);
  end;

  Pause (100); if TouchPresse then Fin;

  { Noir -> Couleurs origines }
  for ix := 0 to 30 do begin
    for i:=0 to 255 do
      with Pal[i] do begin
        if SauvePal[i].R < R+3 then R := SauvePal[i].R else inc (R,3);
        if SauvePal[i].V < V+3 then V := SauvePal[i].V else inc (V,3);
        if SauvePal[i].B < B+3 then B := SauvePal[i].B else inc (B,3);
      end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);

    Pause (50);
  end;

  if TouchPresse then Fin;

  { --- Inversion des couleurs --- }
  AfficheImage ('Inversion des couleurs');
  LitGrandePal (Pal,0,256);
  move (Pal,SauvePal,SizeOf(Pal));

  for i := 0 to 255 do with Pal[i] do begin
    R := 63-R;
    V := 63-V;
    B := 63-B;
  end;

  AttendEcran;
  ChangeGrandePal (Pal,0,256);

  Pause (1000); if TouchPresse then Fin;

  AttendEcran;
  ChangeGrandePal (SauvePal,0,256);

  { --- Retournement vertical --- }
  AfficheImage ('Retournement vertical'); vram := 0;
  for iy:=0 to 199 do begin
    move (Mem[$A000: vram] ,LigneH ,320);
    move (LigneH,LigneB,320);
    for ix:=0 to 319 do LigneH[ix] := LigneB[319-ix];
    move (LigneH ,Mem[$A000: vram] ,320);
    inc (vram,320);
  end;
  Pause (1000); if TouchPresse then Fin;

  { --- Retournement horizontal --- }
  AfficheImage ('Retournemant horizontal'); vram := 0;
  for iy:=0 to 99 do begin
    move (Mem[$A000: vram]       ,LigneH ,320);
    move (Mem[$A000: 64000-vram] ,LigneB ,320);
    move (LigneB            ,Mem[$A000: vram]      ,320);
    move (LigneH ,Mem[$A000: 64000-vram] ,320);
    inc (vram,320);
  end;
  Pause (1000); if TouchPresse then Fin;

  { Zoom - }
  AfficheImage ('Zoom arrire');
  for zoom := 0 downto -4 do begin

    for iy := 0 to 99 do begin
      move (Mem[$A000: iy shl 9 +iy shl 7], LigneH,320);

      for ix:=0 to 159 do PutPixel (ix,iy,LigneH [ix shl 1]);
    end;

    Pause (500);
  end;

  { Zoom + }
  AfficheImage ('Zoom avant');
  for zoom := 0 to 5 do begin
    iy := 99;

    for i := 99 downto 0 do begin
      move (Mem[$A000: iy shl 8 + iy shl 6 + 80], LigneH,160);

      vram := i shl 9 + i shl 7;
      for ix:=0 to 159 do begin
        Mem[$A000: vram    ] := LigneH [ix];
        Mem[$A000: vram+1  ] := LigneH [ix];
        Mem[$A000: vram+320] := LigneH [ix];
        Mem[$A000: vram+321] := LigneH [ix];
        inc (vram,2);
      end;
      dec (iy);
    end;

    Pause (500);
  end;

  if TouchPresse then LitTouche;

  { Adoucit }
  AfficheImage ('Adoucit - enfoncez une touche');  Pause (2000);
  Adouci_AsmPur;
  LitTouche;

  { Impression d'immersion }
  AfficheImage ('Immersion - enfoncez une touche'); Pause (1000);
  repeat
    ix := random (318)+1;
    iy := random (198)+1;
    vram := iy shl 8 + iy shl 6 + ix;

    Mem[$A000: vram-1   ] := Mem[$A000: vram];
    Mem[$A000: vram-320 ] := Mem[$A000: vram];
    Mem[$A000: vram+1   ] := Mem[$A000: vram];
    Mem[$A000: vram+320 ] := Mem[$A000: vram];
  until TouchPresse;
  LitTouche; Pause (1000);

  { Dgoulinade }
  AfficheImage ('Degoulinade - enfoncez une touche'); Pause (1000);
  repeat
    ix := random(319);
    iy := random(199);
    vram := iy shl 8 + iy shl 6 +ix;
    Mem[$A000: vram+321] := Mem[$A000: vram];
  until TouchPresse;
  LitTouche; Pause (1000);

  { Copie ligne / ligne du bas vers le haut }
  AfficheImage ('A la prochaine !');

  iy := 198;
  repeat
    vram := iy shl 8 +iy shl 6;
    move (Mem[$A000: vram], LigneH ,320);
    for i:=199 downto iy do begin
      move (LigneH, Mem[$A000: vram] ,320);
      inc (vram,320);
    end;
    dec (iy);
    Pause (20);
  until iy=0;

  Fin;
end.